unit StructMain;

//     ,
// drag-and-drop 
//   .

//  ,   ,  
// -     .  
//     .

//  ,     .

//     .bak,  
// -   .

interface

uses
Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
Dialogs, StdCtrls, ComCtrls, Menus, AppEvnts, ShellAPI, StructAbout,
ImgList, ToolWin,StructWork, Registry;

type
TMainForm = class(TForm)
  Source: TRichEdit;
  MainMenu1: TMainMenu;
  FileMenu: TMenuItem;
  Open: TMenuItem;
  Save: TMenuItem;
  CloseMnu: TMenuItem;
  OpenDialog: TOpenDialog;
  Work: TMenuItem;
  ApplicationEvents1: TApplicationEvents;
  AboutMnu: TMenuItem;
  ToolBar1: TToolBar;
  ImageList1: TImageList;
  OpenTool: TToolButton;
  WorkTool: TToolButton;
  SaveTool: TToolButton;
  ExitTool: TToolButton;
  About: TMenuItem;
  Readme: TMenuItem;
  ProgressBar: TProgressBar;
  Terminate: TMenuItem;
  Animate: TAnimate;
    N1: TMenuItem;
    AddToOpenWith: TMenuItem;
    RemoveFromOpenWith: TMenuItem;
  procedure CloseMnuClick(Sender: TObject);
  procedure OpenClick(Sender: TObject);
  procedure WorkClick(Sender: TObject);
  procedure SaveClick(Sender: TObject);
  procedure FormCreate(Sender: TObject);
  procedure FormKeyPress(Sender: TObject;
  var Key: Char);
  procedure ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
  procedure FormDestroy(Sender: TObject);
  procedure AboutMnuClick(Sender: TObject);
  procedure ReadmeClick(Sender: TObject);
  procedure CallBack(i:integer);
  procedure TerminateClick(Sender: TObject);
  procedure SetCursors(C:TCursor);
    procedure AddToOpenWithClick(Sender: TObject);
    procedure RemoveFromOpenWithClick(Sender: TObject);
private
  Th:TWorkThread;
  FileName:String;
  Items:TStringList;
  SaveNowMode:boolean;
  { Private declarations }
protected
  procedure WMDropFiles(var Msg: TMessage);
  message wm_DropFiles;
  procedure ReadyForNext(var MSG:TMessage);
  message WM_USER+1;
  
public
  { Public declarations }
end;

var
MainForm: TMainForm;

const ReadyToNext = 4123;

implementation
uses Masks;
{$R *.dfm}

procedure TMainForm.CloseMnuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.OpenClick(Sender: TObject);
var i:Integer;
begin
  if OpenDialog.Execute then
    if OpenDialog.Files.Count=1 then
  begin
    SaveNowMode:=false;
    FileName:=OpenDialog.FileName;
    WorkClick(Sender);
  end
  else
    if Application.MessageBox('  ?',nil,MB_YESNO)=mrYES then
  begin
    for i:=0 to OpenDialog.Files.Count-1 do
    begin
      FileName:=OpenDialog.Files.Strings[i];
      Items.Add(FileName);
    end;
    SaveNowMode:=true;
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
  end;
end;


procedure TMainForm.WorkClick(Sender: TObject);
begin
  WorkTool.Enabled:=false;
  Th:=TWorkThread.Create(true);
  Th.FreeOnTerminate:=true;
  Th.Priority:=tpNormal;
  Th.SetCallback(CallBack);
  Th.Go(FileName);
  SetCursors(crAppStart);
  
end;

procedure TMainForm.SaveClick(Sender: TObject);
var FN:String;
begin
  
  FN:=ChangeFileExt(FileName,'.bak');
  
  if FileExists(FN) then
    DeleteFile(FN);
  
  if RenameFile(FileName,FN) then
  begin
    Source.PlainText:=true;
    Source.Lines.SaveToFile(FileName)
  end
  else
    Application.MessageBox('    ,  .',nil)
  
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i:integer;
begin
  Items:=TStringList.Create;
  FileName:='';
  
  if ParamCount=1 then
  begin
    SaveNowMode:=false;
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
    FileName:=ParamStr(1);
    Source.Lines.BeginUpdate;
    Source.Lines.LoadFromFile(FileName);
    Source.Lines.EndUpdate;
    if not MatchesMask(FileName,'*.pas') then
      Application.MessageBox(',      Delphi.      .',nil)
    else
      WorkClick(nil);
  end;
  
  if ParamCount>1 then
    if Application.MessageBox('  ?',nil,MB_YESNO)=mrYES then
  begin
    for i:=1 to ParamCount do
    begin
      FileName:=ParamStr(i);
      Items.Add(FileName);
    end;
    SaveNowMode:=true;
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
  end;
  
  DragAcceptFiles(Handle, True);
end;

procedure TMainForm.FormKeyPress(Sender: TObject;
var Key: Char);
begin
  if Ord(Key)=VK_ESCAPE then
    close;
end;

procedure TMainForm.ApplicationEvents1Idle(Sender: TObject;
var Done: Boolean);
begin
  Save.Enabled:=(FileName<>'');
  SaveTool.Enabled:=(FileName<>'');
  Work.Enabled:=(Source.Text>'') and (Th=nil);
  WorkTool.Enabled:=(Source.Text>'') and (Th=nil);
  
  Animate.Visible:=not (Th=nil);
  Animate.Active:=not (Th=nil);
  
  if (Th=nil) then
    SetCursors(crArrow) else
      SetCursors(crAppStart);
  
  Terminate.Enabled:=(Th<>nil);
  Done:=true;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DragAcceptFiles(Handle, False);
  Items.Free;
end;


procedure TMainForm.WMDropFiles(var Msg: TMessage);
var
Fname: array[0..MAX_PATH] of Char;
Count,i : integer;
begin
  Count := DragQueryFile( msg.WParam, $FFFFFFFF, FName, MAX_PATH);
  
  if Count=1 then
  begin
    SaveNowMode:=false;
    {     }
    DragQueryFile( THandle(Msg.WParam),
    0, {    }
    Fname,SizeOf(Fname) ) ;
    {   }
    
    FileName:=FName;
    {      }
    DragFinish(THandle(Msg.WParam));
    
    Source.Lines.BeginUpdate;
    Source.Lines.LoadFromFile(FileName);
    Source.Lines.EndUpdate;
    
    if not MatchesMask(FileName,'*.pas') then
      Application.MessageBox(',      Delphi.      .',nil)
    else
      WorkClick(nil);
    
    {
    Items.Add(FileName);
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
}
  end else
    
  if Application.MessageBox('  ?',nil,MB_YESNO)=mrYES then
  begin
    for i:=0 to Count-1 do
    begin
      DragQueryFile( THandle(Msg.WParam),
      i, {    }
      Fname,SizeOf(Fname) ) ;
      {   }
      FileName:=FName;
      Items.Add(FileName);
    end;
    SaveNowMode:=true;
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
  end;
end;



procedure TMainForm.AboutMnuClick(Sender: TObject);
var About:TAboutBox;
begin
  About:=TAboutBox.Create(Application);
  try
    About.ShowModal;
  finally
    About.Free;
  end;
  
end;

procedure TMainForm.ReadmeClick(Sender: TObject);
var FN:String;
begin
  FN:=ExtractFilePath(Application.ExeName)+'Readme.txt';
  ShellExecute(Handle,'open',PChar(FN),nil,nil,SW_SHOW);
end;

procedure TMainForm.CallBack(i: integer);
var //T:TDateTime;
P:Integer;
begin
  ProgressBar.Position:=i;
  if i=101 then
  begin
    ProgressBar.Position:=0;
    
    P:=Source.SelStart;
    Th.GetLines(Source.Lines);
    Source.SelStart:=P;
    
    PostMessage(Handle,WM_USER+1,ReadyToNext,0);
    Th:=nil;
  end;
end;


procedure TMainForm.ReadyForNext(var MSG: TMessage);
begin
  if MSG.WParam=ReadyToNext then
    
  if Items.Count>0 then
  begin
    FileName:=Items.Strings[0];
    {
    Source.Lines.BeginUpdate;
    Source.Lines.LoadFromFile(FileName);
    Source.Lines.EndUpdate;
}
    WorkClick(nil);
    Items.Delete(0);
  end else
    SaveNowMode:=false;
  
end;

procedure TMainForm.TerminateClick(Sender: TObject);
begin
  Items.Clear;
end;

procedure TMainForm.SetCursors(C: TCursor);
var i:integer;
begin

  for i:=0 to ComponentCount-1 do
    if (Components[i] is TControl) then
      TControl(Components[i]).Cursor:=C;
end;

procedure RegisterProgram(ProgName, ProgFile:String);
var R:TRegistry;
begin
  R:=TRegistry.Create;
  try
    R.RootKey:= HKEY_CLASSES_ROOT;
    if not R.OpenKey('Applications\'+ProgName+'\shell\open\command',true) then Exception.Create('   !');
    try
      R.WriteString('','"'+ProgFile+'" "%1"');
    finally
      R.CloseKey;
    end;
  finally
    R.Free;
  end;
end;

procedure UnRegisterProgram(ProgName:String);
var R:TRegistry;
KN:String;
begin
  KN:='Applications\'+ProgName+'\shell\open\command';
  R:=TRegistry.Create;
  try
    R.RootKey:= HKEY_CLASSES_ROOT;
    if R.KeyExists(KN) then
    if not R.DeleteKey(KN) then Exception.Create('   !');
  finally
    R.Free;
  end;
end;


procedure RegisterOpenWith(Extension, ProgName:String);
var R:TRegistry;
var KN:String;
begin
  KN:=Extension+'\OpenWithList\'+ProgName;
  R:=TRegistry.Create;
  try
    R.RootKey:=HKEY_CLASSES_ROOT;
    if not R.KeyExists(KN) then
    begin
      if not R.CreateKey(KN) then Exception.Create('   !');
    end;
  finally
    R.Free;
  end;
end;

procedure UnRegisterOpenWith(Extension, ProgName:String);
var R:TRegistry;
var KN:String;
begin
  KN:=Extension+'\OpenWithList\'+ProgName;
  R:=TRegistry.Create;
  try
    R.RootKey:=HKEY_CLASSES_ROOT;
    if not R.DeleteKey(KN) then Exception.Create('   !');
  finally
    R.Free;
  end;
end;


procedure TMainForm.AddToOpenWithClick(Sender: TObject);
begin
  RegisterProgram('DStruct.exe',Application.ExeName);
  RegisterOpenWith('.pas','DStruct.exe');
end;

procedure TMainForm.RemoveFromOpenWithClick(Sender: TObject);
begin

  UnRegisterProgram('DStruct.exe');
  UnRegisterOpenWith('.pas','DStruct.exe');

end;

end.
