unit StructWork;
interface
uses Classes,SysUtils,Windows;

type TCallBackProc = procedure(p:integer) of object;

type
TWorkThread = class(TThread)
private
  Done:integer;
  PASLines:TStrings;
  CallBack:TCallBackProc;
  FileName:String;
  procedure DoCallBack;
  overload;
  procedure DoCallBack(Progress:integer);
  overload;
  { Private declarations }
protected
  procedure Execute;
  override;
public
  constructor Create(Suspended:boolean);
  destructor Destroy;
  override;
  procedure SetCallback(CB:TCallBackProc);
  procedure Go(FN:String);
  overload;
  procedure Go(Lines:TStrings);
  overload;
  procedure GetLines(Lines:TStrings);
end;

implementation

type TLevelChangeKind = (applyIncluding, applyExcluding, applyOnlyThis, applyNext);
//.,        ,
//,   ,    , 
//   ,      .

//:

{
begin //applyExculuding[+], ,   
  if  then //applyNext[+],  
    Proc(false);
  Proc(true);
end; //applyIncluding[-],  ,   

SomeClass:=TSomeClass.Create;
try  //applyExcluding[+]
  SomeClass.SomeMethod;
finally  //applyOnlyThis[-] -      
  SomeClass.Free; //  -   try
end;  //applyIncluding[-]

:

if SomeBool then
begin // applyNext[+]  , ..  .
  SomeProc;
end;


applyNext  ,   
   :

with SomeObject do
  for i:=1 to N do
    if SomeProperty.SomeBool[i] then
      SomeProperty.SomeMethod(i);

:

with SomeObject do
  for i:=1 to N do
    if SomeProperty.SomeBool[i] then
begin
  SomeProperty.SomeMethod(i);
end;

     ...
   ;-)

}

type TKeyWord = record
  KeyWord:String;
  LevelChange:Integer;
  Kind:TLevelChangeKind;
end;

var KeyWords:array[0..18] of TKeyWord =
(
(KeyWord:  'class of';  LevelChange:-1;  Kind:applyExcluding),// +1,   class
(KeyWord:  'class';     LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'private';   LevelChange:-1;  Kind:applyOnlyThis),
(KeyWord:  'public';    LevelChange:-1;  Kind:applyOnlyThis),
(KeyWord:  'protected'; LevelChange:-1;  Kind:applyOnlyThis),
(KeyWord:  'begin';     LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'record';    LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'asm';       LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'repeat';    LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'case';      LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'try';       LevelChange:+1;  Kind:applyExcluding),
(KeyWord:  'finally';   LevelChange:-1;  Kind:applyOnlyThis),
(KeyWord:  'end';       LevelChange:-1;  Kind:applyIncluding),
(KeyWord:  'until';     LevelChange:-1;  Kind:applyIncluding),
(KeyWord:  'then';      LevelChange:+1;  Kind:applyNext),
(KeyWord:  'else';      LevelChange:+1;  Kind:applyNext),
(KeyWord:  'with';      LevelChange:+1;  Kind:applyNext),
(KeyWord:  'for';       LevelChange:+1;  Kind:applyNext),
(KeyWord:  'while';     LevelChange:+1;  Kind:applyNext)

);

//    :
const CRLFAfter:array[1..5] of String=
('then','begin','else','do','record');

{SkLevel -   }
{InComment1,2 -   }
{InStringConstant -   }
{LocalLevel -   applyNext}
type TCheckPointInfo=record
  SkLevel:Integer;
  InComment1,InComment2: boolean;
  InStringConstant:boolean;
  LocalLevel, StructureLevel:Integer;
end;

function IsCharInID(C:Char):boolean;
begin
  Result:=C in ['a'..'z','A'..'Z','0'..'9','.','_'];
end;


function SubStringPresent(Sub,S:String;at:integer;StandAlone:boolean):boolean;
var
i:integer;
NextChar:Char;
PrevChar:Char;
SubS:String;
begin
  if Length(S)<Length(Sub)+at-1 then
  begin
    Result:=false;
    exit;
  end;
  SubS:=copy(S,at,Length(Sub));
  
  //      
  // , .    -)
  i:=at+Length(Sub);
  if i<=Length(S) then
    NextChar:=S[i]
  else
    NextChar:=' ';
  
  i:=at-1;
  if i>0 then
    PrevChar:=S[i]
  else
    PrevChar:=' ';
  if StandAlone then
    Result:= (SubS=Sub)
  and not IsCharInID(NextChar)
  and not IsCharInID(PrevChar)
  else
    Result:= (SubS=Sub);
end;


procedure IsKeyWord(S:String;out LevelChange:integer;out ChangeKind:TLevelChangeKind);
var i,j:integer;
KW:String;
begin
  LevelChange:=0;
  S:=AnsiLowerCase(S);
  
  for i:=1 to Length(S) do
    for j:=Low(KeyWords) to high(KeyWords) do
  begin
    KW:=KeyWords[j].KeyWord;
    if SubStringPresent(KW,S,i,true) then
    begin
      LevelChange:=KeyWords[j].LevelChange;
      ChangeKind:= KeyWords[j].Kind;
    end;
  end;
end;


function ExtractOneOperator(var S:String;var CPInfo:TCheckPointInfo):String;
var i,j:Integer;
Turning:boolean;
Flag:boolean;
begin
  Turning:=false;
  Result:='';
  Flag:=false;
  for i:=1 to Length(S) do
  begin
    
    {"" }
    if not CPInfo.InStringConstant and not CPInfo.inComment1 then begin
        if SubStringPresent('(*',S,i,false) then CPInfo.InComment2:=true;
          if SubStringPresent('*)',S,i,false) then CPInfo.InComment2:=false;
    end;
    
    { "//"}
    if not CPInfo.inComment1 and not CPInfo.InComment2 and not CPInfo.InStringConstant then
      if SubStringPresent('//',S,i,false) then
    begin
      {  }
      Result:=S;
      S:='';
      break;
    end;
    
    {CRLF    - begin, then, do   }
    if not CPInfo.inComment1
    and not CPInfo.InComment2
    and not CPInfo.InStringConstant
    and (CPInfo.SkLevel=0) then
    begin
      for j:=Low(CRLFAfter) to High(CRLFAfter) do
        if SubStringPresent(CRLFAfter[j],AnsiLowerCase(S),i,true) then
      begin
        Result:=copy(S,1,i+Length(CRLFAfter[j]));
        Delete(S,1,Length(Result));
        flag:=true;
        break;
      end;
    end;
    
    if flag then
      break;
    
    case S[i] of
      { ,  }
      '{': if not CPInfo.InStringConstant and not CPInfo.InComment2 then CPInfo.InComment1:=true;
        '}': if not CPInfo.InStringConstant and not CPInfo.InComment2 then CPInfo.InComment1:=false;
          
      {}
      '(':if not CPInfo.InStringConstant and CPInfo.InComment1 and not CPInfo.InComment2 then Inc(CPInfo.SkLevel);
        ')':if not CPInfo.InStringConstant and CPInfo.InComment1 and not CPInfo.InComment2 then Dec(CPInfo.SkLevel);
          
      {  }
      '''': if not CPInfo.InComment1 and not CPInfo.InComment2 then
        CPInfo.InStringConstant:=not CPInfo.InStringConstant;
      
      { --    }
      ';': if not CPInfo.InComment1 and not CPInfo.InComment2 and (CPInfo.SkLevel=0)
      then Turning:=true;
        
      ' ':{ ,    -   else  };
      
      else
        if Turning and not CPInfo.InComment1 and not CPInfo.InComment2 and not CPInfo.InStringConstant and not (CPInfo.SkLevel>0) then
      begin
        Result:=copy(S,1,i-1);
        Delete(S,1,i-1);
        break;
      end;
    end; {case}
  end; {for}
  
  if Result='' then begin
      Result:=S;
    S:='';
  end;
  
  with CPInfo do
    if not InComment1 and not InComment2 then
      Result:=Trim(Result);
  
end;

procedure DivideToStrings(Lines:TStrings);
var Tmp:TStrings;
i:integer;
S:String;
Stat:String;
CheckPointInfo:TCheckPointInfo;
begin
  CheckPointInfo.SkLevel:=0;
  CheckPointInfo.InComment1:=false;
  CheckPointInfo.InComment2:=false;
  CheckPointInfo.InStringConstant:=false;
  
  Tmp:=TStringList.Create;
  try
    
    for i:=0 to Lines.Count-1 do
    begin
      S:=Lines.Strings[i];
      repeat
        Stat:=ExtractOneOperator(S,CheckPointInfo);
        Tmp.Add(Stat);
      until S='';
    end;
    
    Lines.Clear;
    Lines.Assign(Tmp);
  finally
    Tmp.Free;
  end;
  
end;

function KeyWordInPos(SourceString:String;P:Integer;KeyWord:String):boolean;
begin
  Result:=false;
  if Length(SourceString)-P+1<Length(KeyWord) then exit;
    if copy(SourceString,P,Length(KeyWord))<>KeyWord then exit;
      if P+Length(KeyWord)=Length(SourceString) then Result:=true else
          Result:=not IsCharInID(SourceString[P+Length(KeyWord)]);
end;

procedure DetectLevelChanges(S:String;i:Integer;out LevelChange:Integer;out Kind:TLevelChangeKind);
var j:integer;
begin
  S:=AnsiLowerCase(S);
  LevelChange:=0;
  
  if i>1 then
    if IsCharInID(S[i-1])  then exit;
      
  for j:=Low(Keywords) to High(Keywords) do
  if KeyWordInPos(S,i,KeyWords[j].KeyWord) then begin
      Kind:=Keywords[j].Kind;
    LevelChange:=Keywords[j].LevelChange;
    break;
  end;
end;



function AnalyseLine(S:String;var CPInfo:TCheckPointInfo):String;
var i:Integer;
LevelChange:Integer; Kind:TLevelChangeKind;
OldCPInfo:TCheckPointInfo;

AddToCurrentLevel:Integer;

begin
  OldCPInfo:=CPInfo;
  AddToCurrentLevel:=0;
  CPInfo.LocalLevel:=0;
  
  
  
  for i:=1 to Length(S) do
  begin
    
    
    {"" }
    if not CPInfo.inComment1 and not CPInfo.InStringConstant then begin
        if SubStringPresent('(*',S,i,false) then CPInfo.InComment2:=true;
          if SubStringPresent('*)',S,i,false) then CPInfo.InComment2:=false;
    end;
    
    { "//"}
    if not CPInfo.inComment1 and not CPInfo.InComment2 and not CPInfo.InStringConstant then
      if SubStringPresent('//',S,i,false) then
    begin
      {  }
      break;
    end;
    
    
    case S[i] of
      { ,  }
      '{': if not CPInfo.InComment2 and not CPInfo.InStringConstant then CPInfo.InComment1:=true;
        '}': if not CPInfo.InComment2 and not CPInfo.InStringConstant then CPInfo.InComment1:=false;
          
      {}
      '(':if not CPInfo.InComment1 and not CPInfo.InComment2 and not CPInfo.InStringConstant then Inc(CPInfo.SkLevel);
        ')':if not CPInfo.InComment1 and not CPInfo.InComment2 and not CPInfo.InStringConstant then Dec(CPInfo.SkLevel);
          
      {  }
      '''': if not CPInfo.InComment1 and not CPInfo.InComment2 then
        CPInfo.InStringConstant:=not CPInfo.InStringConstant;
      
      'A'..'Z','a'..'z':
      if not CPInfo.InComment1 and
      not CPInfo.InComment2 and
      not CPInfo.InStringConstant and
      not (CPInfo.SkLevel>0) then
      begin
        
        DetectLevelChanges(S,i,LevelChange,Kind);
        
        if (LevelChange<>0) and (Kind<>applyNext) then
          OldCPInfo.LocalLevel:=0;
        
        
        case Kind of
          applyExcluding: CPInfo.StructureLevel:=CPInfo.StructureLevel+LevelChange;
          applyIncluding:
          begin
            CPInfo.StructureLevel:=CPInfo.StructureLevel+LevelChange;
            AddToCurrentLevel:=AddToCurrentLevel+LevelChange;
          end;
          applyOnlyThis: AddToCurrentLevel:=AddToCurrentLevel+LevelChange;
          applyNext: CPInfo.LocalLevel:=CPInfo.LocalLevel+LevelChange;
        end;
        
      end;
    end; {case}
  end; {for}
  
  Result:='';
  with OldCPInfo do
    if InComment1 or InComment2 then
      Result:=S
  else
  begin
    if (LocalLevel+AddToCurrentLevel+StructureLevel)>0 then
      For i:=1 to (LocalLevel+AddToCurrentLevel+StructureLevel)*2 do
        Result:=Result+' ';
    Result:=Result+TrimLeft(S);
  end;
  if CPInfo.LocalLevel<>0 then CPInfo.LocalLevel:=CPInfo.LocalLevel+OldCPInfo.LocalLevel
    
end;




procedure FormatDividedStrings(Lines:TStrings);
var CheckPointInfo:TCheckPointInfo;
i:integer;
Tmp:TStringList;
begin
  CheckPointInfo.SkLevel          :=0;
  CheckPointInfo.InComment1       :=false;
  CheckPointInfo.InComment2       :=false;
  CheckPointInfo.InStringConstant :=false;
  CheckPointInfo.LocalLevel       :=0;
  CheckPointInfo.StructureLevel   :=0;
  
  Tmp:=TStringList.Create;
  try
    for i:=0 to Lines.Count-1 do
      Tmp.Add( AnalyseLine(Lines.Strings[i],CheckPointInfo) );
    Lines.Clear;
    Lines.Assign(Tmp);
  finally
    Tmp.Free;
  end;
end;

procedure FormatStrings(Lines:TStrings);
begin
  Lines.BeginUpdate;
  try
    DivideToStrings(Lines);
    FormatDividedStrings(Lines);
  finally
    Lines.EndUpdate;
  end;
end;



{ TWorkThread }

constructor TWorkThread.Create(Suspended: boolean);
begin
  CallBack:=nil;
  PASLines:=TStringList.Create;
  inherited;
end;

procedure TWorkThread.DoCallBack;
begin
  if Assigned(CallBack) then CallBack(Done);
end;

procedure TWorkThread.Execute;
var Tmp,Res:TStrings;
i:integer;
S:String;
Stat:String;
CheckPointInfo:TCheckPointInfo;
Progress,OldP:integer;
begin
  DoCallBack(0);
  
  Tmp:=TStringList.Create;
  Res:=TStringList.Create;
  try
    Res.Assign(PASLines);
    {DIVIDE TO STRINGS}
    
    CheckPointInfo.SkLevel:=0;
    CheckPointInfo.InComment1:=false;
    CheckPointInfo.InComment2:=false;
    CheckPointInfo.InStringConstant:=false;
    
    OldP:=0;
    for i:=0 to Res.Count-1 do
    begin
      S:=PASLines.Strings[i];
      repeat
        Stat:=ExtractOneOperator(S,CheckPointInfo);
        Tmp.Add(Stat);
        Progress:=50*i div Res.Count;
        if Progress>OldP+2 then begin
            DoCallBack(Progress);
          OldP:=Progress;
        end;
      until S='';
    end;
    Res.Assign(Tmp);
    TMP.Clear;
    
    {/DIVIDE TO STRINGS}
    DoCallBack(50);
    {FORMAT DIVIDED STRINGS}
    
    CheckPointInfo.SkLevel          :=0;
    CheckPointInfo.InComment1       :=false;
    CheckPointInfo.InComment2       :=false;
    CheckPointInfo.InStringConstant :=false;
    CheckPointInfo.LocalLevel       :=0;
    CheckPointInfo.StructureLevel   :=0;
    
    for i:=0 to Res.Count-1 do
    begin
      Tmp.Add( AnalyseLine(Res.Strings[i],CheckPointInfo) );
      Progress:=50+50*i div Res.Count;
      if Progress>OldP+2 then begin
          DoCallBack(Progress);
        OldP:=Progress;
      end;
    end;
    Res.Assign(Tmp);
    
    {/FORMAT DIVIDED STRINGS}
    PASLines.Assign(Res);
  finally
    Tmp.Free;
    Res.Free;
  end;
  
  if FileName<>'' then
  try
    S:=ChangeFileExt(FileName,'.bak');
    if FileExists(S) then DeleteFile(PChar(S));
      if not RenameFile(FileName,S) then Exception.Create('  '+FileName);
        PasLines.SaveToFile(FileName);
    except
    on E:Exception do MessageBox(0,PChar(E.Message),'Error',MB_OK);
  end;
  DoCallBack(101);
end;

procedure TWorkThread.SetCallback(CB: TCallBackProc);
begin
  CallBack:=CB;
end;

procedure TWorkThread.Go(FN:String);
begin
  if not Suspended then exit;
    PASLines.BeginUpdate;
  FileName:=FN;
  PASLines.LoadFromFile(FN);
  PASLines.EndUpdate;
  Resume;
end;

procedure TWorkThread.GetLines(Lines: TStrings);
var S:TMemoryStream;
begin
  Lines.BeginUpdate;
  S:=TMemoryStream.Create;
  try
    // -  ,    assign
    //13  Assign  <1   Stream
    PasLines.SaveToStream(S);
    S.Seek(0,soFromBeginning);
    Lines.LoadFromStream(S);
  finally
    Lines.EndUpdate;
    S.Free;
  end;
end;

destructor TWorkThread.Destroy;
begin
  PASLines.Free;
end;

procedure TWorkThread.DoCallBack(Progress: integer);
begin
  Done:=Progress;
  Synchronize(DoCallBack);
end;

procedure TWorkThread.Go(Lines: TStrings);
begin
  FileName:='';
  if not Suspended then exit;
    PASLines.Assign(Lines);
  Resume;
end;

end.
